Crypto++ 8.2 Free C++ class library of cryptographic schemes

Public Member Functions | Static Public Attributes | List of all members
IteratedHashWithStaticTransform< T_HashWordType, T_Endianness, T_BlockSize, T_StateSize, T_Transform, T_DigestSize, T_StateAligned > Class Template Reference

Iterated hash with a static transformation function. More...

Inheritance diagram for IteratedHashWithStaticTransform< T_HashWordType, T_Endianness, T_BlockSize, T_StateSize, T_Transform, T_DigestSize, T_StateAligned >:

## Public Member Functions
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
Public Member Functions inherited from ClonableImpl< T_Transform, AlgorithmImpl< IteratedHash< T_HashWordType, T_Endianness, T_BlockSize >, T_Transform > >
Clonable * | Clone () const
| Create a copy of this object. More...
Public Member Functions inherited from AlgorithmImpl< IteratedHash< T_HashWordType, T_Endianness, T_BlockSize >, T_Transform >
std::string | AlgorithmName () const
| The algorithm name. More...
Public Member Functions inherited from IteratedHash< T_HashWordType, T_Endianness, T_BlockSize >
unsigned int | BlockSize () const
| Provides the block size of the hash. More...
ByteOrder | GetByteOrder () const
| Provides the byte order of the hash. More...
void | CorrectEndianess (HashWordType *out, const HashWordType *in, size_t byteCount)
| Adjusts the byte ordering of the hash. More...
Public Member Functions inherited from IteratedHashBase< T_HashWordType, HashTransformation >
| IteratedHashBase ()
| Construct an IteratedHashBase.
unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
byte * | CreateUpdateSpace (size_t &size)
| Requests space which can be written into by the caller. More...
void | Restart ()
| Restart the hash. More...
void | TruncatedFinal (byte *digest, size_t digestSize)
| Computes the hash of the current message. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...

## Static Public Attributes
static const int | DIGESTSIZE = T_DigestSize ? T_DigestSize : T_StateSize
Static Public Attributes inherited from IteratedHash< T_HashWordType, T_Endianness, T_BlockSize >
static const int | BLOCKSIZE

## Additional Inherited Members
Public Types inherited from IteratedHash< T_HashWordType, T_Endianness, T_BlockSize >
typedef T_Endianness | ByteOrderClass
typedef T_HashWordType | HashWordType
Public Types inherited from IteratedHashBase< T_HashWordType, HashTransformation >
typedef T_HashWordType | HashWordType
Static Public Member Functions inherited from AlgorithmImpl< IteratedHash< T_HashWordType, T_Endianness, T_BlockSize >, T_Transform >
static std::string CRYPTOPP_API | StaticAlgorithmName ()
| The algorithm name. More...

## Detailed Description

### template<class T_HashWordType, class T_Endianness, unsigned int T_BlockSize, unsigned int T_StateSize, class T_Transform, unsigned int T_DigestSize = 0, bool T_StateAligned = false>
class IteratedHashWithStaticTransform< T_HashWordType, T_Endianness, T_BlockSize, T_StateSize, T_Transform, T_DigestSize, T_StateAligned >

Iterated hash with a static transformation function.

Template Parameters

  T_HashWordType | Hash word type
  T_Endianness | Endianness type of hash
  T_BlockSize | Block size of the hash
  T_StateSize | Internal state size of the hash
  T_Transform | HashTransformation derived class
  T_DigestSize | Digest size of the hash
  T_StateAligned | Flag indicating if state is 16-byte aligned

See also
  HashTransformation, MessageAuthenticationCode

Definition at line 180 of file iterhash.h.

## Member Function Documentation

## ◆ DigestSize()

template<class T_HashWordType, class T_Endianness, unsigned int T_BlockSize, unsigned int T_StateSize, class T_Transform, unsigned int T_DigestSize = 0, bool T_StateAligned = false>

unsigned int IteratedHashWithStaticTransform< T_HashWordType, T_Endianness, T_BlockSize, T_StateSize, T_Transform, T_DigestSize, T_StateAligned >::DigestSize | ( |  | ) | const
| inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash, in bytes

DigestSize() returns `DIGESTSIZE`.

Implements HashTransformation.

Definition at line 191 of file iterhash.h.

The documentation for this class was generated from the following file:

- iterhash.h